<template>
  <div class="edit-risk-container">
    <ob-form
      okText="Сохранить"
      :formData="formData"
      :formModel="formModel"
      :dropdownMenu="dropdownMenu"
      @submit="onSubmit"
    >
      <div class="row">
        <div class="col-xs-12">
          <ObInput
            label="Текущая оценка"
            :readonly="true"
            :preIcon="getRiskClass(risk.riskGroupColor)"
            v-model="currentRiskTitle"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ObSelector
            label="Ваша новая оценка"
            placeholder="Выберите группу риска"
            :items="risksList"
            v-model="formData.riskUuid"
            @selected="onSelectRisk"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ObTextarea
            label="Комментарий"
            :disabled="isCommentDisabled"
            :required="!isCommentDisabled"
            v-model="formData.comment"
          />
        </div>
      </div>
    </ob-form>
  </div>
</template>

<script>
import riskIconMixin from "@/mixins/risk-icon";
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import { required, requiredIf } from "vuelidate/lib/validators";
import api from "@/api";

import ObForm from "common-components/src/obComponents/obForm";
import ObSelector from "common-components/src/obComponents/obSelect";
import ObTextarea from "common-components/src/obComponents/obTextarea";
import ObInput from "common-components/src/obComponents/obInput";

// import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown"

export default {
  components: { ObForm, ObSelector, ObTextarea, ObInput },
  mixins: [riskIconMixin, FormValidationMixin],
  props: {
    risk: {
      type: Object,
      required: true
    },
    uuid: {
      type: String,
      required: true
    }
  },
  computed: {
    currentRiskTitle: ({ risk, getNumberRisk }) =>
      `Группа риска ${getNumberRisk(risk.riskGroupColor)}`,
    isCommentDisabled: ({ formData, risk }) =>
      !formData.riskUuid || formData.riskUuid === risk.riskGroupUuid,
    formModel() {
      return {
        comment: {
          validator: {
            required: requiredIf(() => !this.isCommentDisabled)
          }
        },
        riskUuid: {
          validator: {
            required
          }
        }
      };
    }
  },
  data() {
    return {
      risksList: [],
      dropdownMenu: [
        {
          title: "История изменений оценки",
          method: () => this.$emit("openRiskHistory")
        }
      ],
      formData: {
        riskUuid: null,
        comment: ""
      }
    };
  },
  watch: {
    field() {
      this.getRisksList();
    },
    risk: {
      deep: true,
      handler() {
        this.getRisksList();
      }
    }
  },
  created() {
    this.getRisksList();
  },
  methods: {
    async getRisksList() {
      const response = await api.taskMonitor.getResourceRiskGroup();
      this.risksList = response.data.risk_group
        .map(r => {
          return {
            number: this.getNumberRisk(r.risk_group_color),
            icon: this.getRiskClass(r.risk_group_color),
            title: `Группа риска ${this.getNumberRisk(r.risk_group_color)}`,
            uuid: r.risk_group_uuid,
            subtitle:
              r.risk_group_uuid === this.risk.riskGroupUuid
                ? "Комментарий не потребуется"
                : null
          };
        })
        .sort((a, b) => a.number - b.number);
    },

    onSelectRisk({ uuid }) {
      if (uuid === this.risk.riskGroupUuid) this.formData.comment = "";
    },
    async onSubmit() {
      try {
        const payload = this.formData;

        const response = await api.resources.updateResourceRisk(
          this.uuid,
          payload
        );

        this.$notification({
          type: "system_notification_success",
          message: "Оценка успешно изменена"
        });

        if (response && response.error)
          throw `Ошибка при изменении оценки: ${response.message}`;

        this.$emit("editRisk");
      } catch (e) {
        console.error(e);
        this.$notification({ type: "system_notification_error", message: e });
      }
    }
  }
};
</script>
